/*
 * PM - 2016
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>

#include "lcd.h"

void intro()
{
	LCD_printAt(LCD_OFFSET_R0, "Ungureanu Diana");
	LCD_printAt(LCD_OFFSET_R1, "Grupa: 332CB");
	LCD_printAt(LCD_OFFSET_R3, "PM 2018");
	_delay_ms(8000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);
}

void showMenuAndWait(int *state) {
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_printAt(LCD_OFFSET_R0, "Choose a game: ");
	LCD_printAt(LCD_OFFSET_R1, "Hangman");
	LCD_printAt(LCD_OFFSET_R2, "Tic-Tac-Toe");

	int currentRow = 0;

	while(1) {

		if(currentRow == 0) {
			LCD_putCharAt(LCD_OFFSET_R0 + 15, 'X');
			LCD_putCharAt(LCD_OFFSET_R1 + 15, ' ');
			LCD_putCharAt(LCD_OFFSET_R2 + 15, ' ');
		}
		else if(currentRow == 1) {
			LCD_putCharAt(LCD_OFFSET_R0 + 15, ' ');
			LCD_putCharAt(LCD_OFFSET_R1 + 15, 'X');
			LCD_putCharAt(LCD_OFFSET_R2 + 15, ' ');
		}
		else {
			LCD_putCharAt(LCD_OFFSET_R0 + 15, ' ');
			LCD_putCharAt(LCD_OFFSET_R1 + 15, ' ');
			LCD_putCharAt(LCD_OFFSET_R2 + 15, 'X');
		}
		if ((PINB & (1 << PB0)) == 0) {
			currentRow = ((currentRow - 1) + 3) % 3;
			_delay_ms(150);
		}
		else if((PINB & (1 << PB1)) == 0) {
			currentRow = (currentRow + 1) % 3;
			_delay_ms(150);
		}
		else if((PINB & (1 << PB3)) == 0) {

			if(currentRow == 1) {
				*state = 2;
				_delay_ms(150);
				break;
			}
			else if(currentRow == 2) {
				*state = 3; 
				_delay_ms(150);
				break;
			}
			_delay_ms(150);
		}
	}

}

void playHangman(int *state) {

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_printAt(LCD_OFFSET_R1, "Guess the word!");
	LCD_printAt(LCD_OFFSET_R2, "You have 7 lives");
	_delay_ms(4000);
	LCD_writeInstr(LCD_INSTR_clearDisplay);

	int i = 0;

	char* words[5]={"HIPERACTIV", "DRUMETIE", "PROIECTE", "ASCUTITOARE", "CEASORNIC"};
	int lengths[5]={10, 8, 8, 11, 9};

	int index = 0;

	char *chosenWord = words[index];
	int wordSize = lengths[index];

	for (i = 0; i < wordSize; i++)
		LCD_printAt(LCD_OFFSET_R1 + i, "_");

	int numberOfLives = 7;
	int foundLetters = 0;

	char alphabet[26]={'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'};
	

	while(1) {

		int letterSelected = 0;

		if(foundLetters == wordSize) {
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(LCD_OFFSET_R1, "Congratulations!");
			LCD_printAt(LCD_OFFSET_R2, "You won!");
			_delay_ms(4000);
			*state = 0;
			break;
		} else if(numberOfLives == 0) {
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(LCD_OFFSET_R1, "Game over :(");
			_delay_ms(4000);
			*state = 0;
			break;
		}

		LCD_printAt(LCD_OFFSET_R3, "Lives left: ");
		LCD_putCharAt(LCD_OFFSET_R3 + 13, (numberOfLives + '0'));

		LCD_printAt(LCD_OFFSET_R2, "Choose a letter: ");

		LCD_putCharAt(LCD_OFFSET_R2 + 17, alphabet[letterSelected]);

		while(!((PINB & (1 << PB1)) == 0)) {
			if((PINB & (1 << PB0)) == 0) {
				letterSelected = ((letterSelected - 1) + 26) % 26;
				LCD_putCharAt(LCD_OFFSET_R2 + 17, alphabet[letterSelected]);
				_delay_ms(150);
			} else if((PINB & (1 << PB3)) == 0) {
				letterSelected = (letterSelected + 1) % 26;
				LCD_putCharAt(LCD_OFFSET_R2 + 17, alphabet[letterSelected]);
				_delay_ms(150);
			}
			_delay_ms(150);
		}

		_delay_ms(150);

		int nrOfApparitions = 0;

		for(i = 0; i < wordSize; i++) {
			if(alphabet[letterSelected] == chosenWord[i]) {
				LCD_putCharAt(LCD_OFFSET_R1+ i, alphabet[letterSelected]);
				nrOfApparitions++;
				chosenWord[i] = '*';
			}
		}

		if(nrOfApparitions == 0)
			numberOfLives--;
		else
			foundLetters += nrOfApparitions;

	}


}

void drawGame() {
	LCD_printAt(LCD_OFFSET_R0, "___");
	LCD_printAt(LCD_OFFSET_R1, "___");
	LCD_printAt(LCD_OFFSET_R2, "___");
}

int checkIfWin(int player, int matrix[3][3]) {

	if( (matrix[0][0] == matrix[1][1]) && (matrix[1][1] == matrix[2][2]) && (matrix[0][0] == player))
		return 1;
	else if((matrix[0][2] == matrix[1][1]) && (matrix[1][1] == matrix[2][0]) && (matrix[1][1] == player))
		return 1;
	else if((matrix[0][0] == matrix[1][0]) && (matrix[1][0] == matrix[2][0]) && (matrix[0][0] == player))
		return 1;
	else if((matrix[0][1] == matrix[1][1]) && (matrix[1][1] == matrix[2][1]) && (matrix[1][1] == player))
		return 1;
	else if((matrix[0][2] == matrix[1][2]) && (matrix[1][2] == matrix[2][2]) && (matrix[2][2] == player))
		return 1;
	else if((matrix[0][0] == matrix[0][1]) && (matrix[0][1] == matrix[0][2]) && (matrix[0][0] == player))
		return 1;
	else if((matrix[1][0] == matrix[1][1]) && (matrix[1][1] == matrix[1][2]) && (matrix[1][1] == player))
		return 1;
	else if((matrix[2][0] == matrix[2][1]) && (matrix[2][1] == matrix[2][2]) && (matrix[2][2] == player))
		return 1;

	return 0;
}

void drawBoard(int matrix[3][3], int playerPosition) {

	int j;

	for(j = 0; j < 3; j++) {
		if(matrix[0][j] == 1)
			LCD_putCharAt(LCD_OFFSET_R0 + j, 'X');
		else if(matrix[0][j] == 2)
			LCD_putCharAt(LCD_OFFSET_R0 + j, 'O');
		else if(matrix[0][j] == 0)
			LCD_putCharAt(LCD_OFFSET_R0 + j, '_');

		if(playerPosition >= 0 && playerPosition <= 2)
			LCD_putCharAt(LCD_OFFSET_R0 + playerPosition, '|');
	}

	for(j = 0; j < 3; j++) {
		if(matrix[1][j] == 1)
			LCD_putCharAt(LCD_OFFSET_R1 + j, 'X');
		else if(matrix[1][j] == 2)
			LCD_putCharAt(LCD_OFFSET_R1 + j, 'O');
		else if(matrix[1][j] == 0)
			LCD_putCharAt(LCD_OFFSET_R1 + j, '_');

		if(playerPosition >= 3 && playerPosition <= 5)
			LCD_putCharAt(LCD_OFFSET_R1 + playerPosition - 3, '|');
	}

	for(j = 0; j < 3; j++) {
		if(matrix[2][j] == 1)
			LCD_putCharAt(LCD_OFFSET_R2 + j, 'X');
		else if(matrix[2][j] == 2)
			LCD_putCharAt(LCD_OFFSET_R2 + j, 'O');
		else if(matrix[2][j] == 0)
			LCD_putCharAt(LCD_OFFSET_R2 + j, '_');

		if(playerPosition >= 6 && playerPosition <= 8)
			LCD_putCharAt(LCD_OFFSET_R2 + playerPosition - 6, '|');
	}

}

void playTicTacToe(int * state) {

	LCD_writeInstr(LCD_INSTR_clearDisplay);

	int player1Position = 0;
	int player2Position = 0;

	int gameState = 1;
	int win = 0;
	int winner = -1;
	int freeSpaces = 9;

	int matrix[3][3] = { {0} };

	drawGame();

	LCD_putCharAt(LCD_OFFSET_R0, '|');

	while(gameState != 0) {
		switch(gameState) {

			case 1: {

				while(!((PINB & (1 << PB1)) == 0)) {
					if((PINB & (1 << PB0)) == 0) {
						player1Position = ((player1Position - 1) + 9) % 9;
						drawBoard(matrix, player1Position);
						_delay_ms(150);
					} else if((PINB & (1 << PB3)) == 0) {
						player1Position = (player1Position + 1) % 9;

						drawBoard(matrix, player1Position);
						_delay_ms(150);
					}
					_delay_ms(150);
				}
				_delay_ms(150);

				if(player1Position >= 0 && player1Position <= 2)
					matrix[0][player1Position] = 1;
				else if(player1Position >= 3 && player1Position <= 5)
					matrix[1][player1Position - 3] = 1;
				else
					matrix[2][player1Position - 6] = 1;

				if(player1Position >= 0 && player1Position <= 2)
					LCD_putCharAt(LCD_OFFSET_R0 + player1Position, 'X');
				else if(player1Position >= 3 && player1Position <= 5)
					LCD_putCharAt(LCD_OFFSET_R1 + (player1Position - 3), 'X');
				else
					LCD_putCharAt(LCD_OFFSET_R2 + (player1Position - 6), 'X');

				_delay_ms(1000);

				freeSpaces -= 1;

				win = checkIfWin(1, matrix);

				if(win == 1) {
					gameState = 0;
					winner = 1;
				} else if(freeSpaces == 0) {
					gameState = 3;
				} else {
					gameState = 2;
				}


				break;
			}
			case 2: {

				while(!((PINB & (1 << PB1)) == 0)) {
					if((PINB & (1 << PB0)) == 0) {
						player2Position = ((player2Position - 1) + 9) % 9;
						drawBoard(matrix, player2Position);
						_delay_ms(150);
					} else if((PINB & (1 << PB3)) == 0) {
						player2Position = (player2Position + 1) % 9;
						drawBoard(matrix, player2Position);
						_delay_ms(150);
					}
					_delay_ms(150);
				}
				_delay_ms(150);

				if(player2Position >= 0 && player2Position <= 2)
					matrix[0][player2Position] = 2;
				else if(player2Position >= 3 && player2Position <= 5)
					matrix[1][player2Position - 3] = 2;
				else
					matrix[2][player2Position - 6] = 2;

				if(player2Position >= 0 && player2Position <= 2)
					LCD_putCharAt(LCD_OFFSET_R0 + player2Position, 'O');
				else if(player2Position >= 3 && player2Position <= 5)
					LCD_putCharAt(LCD_OFFSET_R1 + (player2Position - 3), 'O');
				else
					LCD_putCharAt(LCD_OFFSET_R2 + (player2Position - 6), 'O');

				_delay_ms(1000);

				freeSpaces -= 1;

				win = checkIfWin(2, matrix);

				if(win == 1) {
					gameState = 0;
					winner = 2;
				} else if(freeSpaces == 0) {
					gameState = 3;
				} else {
					gameState = 1;
				}

				break;
			}
			case 3: {
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_printAt(LCD_OFFSET_R1, "It's a draw");
				_delay_ms(4000);
				gameState = 0;

				break;
			}
			default: {
				break;
			}
		}
	}

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_printAt(LCD_OFFSET_R1, "Player ");
	LCD_putCharAt(LCD_OFFSET_R1 + 7, winner + '0');
	LCD_printAt(LCD_OFFSET_R1 + 8, " wins!");
	LCD_printAt(LCD_OFFSET_R2, "Congratulations!");
	_delay_ms(4000);

	*state = 0;
	
}

int main(void) 
{	
	LCD_init();

	intro();

	int *state = 0;

	DDRB &= ~(1 << PB4);
	PORTB |= (1 << PB4);

	DDRB &= ~(1 << PB3);
	PORTB |= (1 << PB3);

	DDRB &= ~(1 << PB2);
	PORTB |= (1 << PB2);

	DDRB &= ~(1 << PB1);
	PORTB |= (1 << PB1);

	DDRB &= ~(1 << PB0);
	PORTB |= (1 << PB0);
	
	showMenuAndWait(state);
	LCD_writeInstr(LCD_INSTR_clearDisplay);

	while(1) {
		switch((*state)) {
			case 2: {
				playHangman(state);
				break;
			}
			case 3: {
				playTicTacToe(state);
				break;
			}
			case 0: {
				showMenuAndWait(state);
				break;
			}
			default: {
				break;
			}
		}
	}

	return 0;
}
